unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Shellapi, ExtCtrls, Clipbrd, Menus;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Memo2: TMemo;
    Memo3: TMemo;
    Memo4: TMemo;
    Button2: TButton;
    Label1: TLabel;
    Button3: TButton;
    Memo5: TMemo;
    Timer1: TTimer;
    Label3: TLabel;
    Timer2: TTimer;
    Timer3: TTimer;
    Memo6: TMemo;
    Timer4: TTimer;
    Memo7: TMemo;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Memo8: TMemo;
    ComboBox1: TComboBox;
    PopupMenu1: TPopupMenu;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    MarkAll1: TMenuItem;
    PopupMenu2: TPopupMenu;
    Copy2: TMenuItem;
    Paste2: TMenuItem;
    MarkAll2: TMenuItem;
    Button1: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
     procedure Timer3Timer(Sender: TObject);
    procedure Timer4Timer(Sender: TObject);
    procedure Memo1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Memo4KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Paste1Click(Sender: TObject);
    procedure MarkAll1Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Copy2Click(Sender: TObject);
    procedure Paste2Click(Sender: TObject);
    procedure MarkAll2Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);


  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  automode : boolean;
  oldkey: String;

implementation

{$R *.dfm}

procedure ExecuteAndWait(const aCommando: string);
var
  tmpStartupInfo: TStartupInfo;
  tmpProcessInformation: TProcessInformation;
  tmpProgram: String;
begin
  tmpProgram := trim(aCommando);
  FillChar(tmpStartupInfo, SizeOf(tmpStartupInfo), 0);
  with tmpStartupInfo do
  begin
    cb := SizeOf(TStartupInfo);
    wShowWindow := SW_HIDE;
  end;

  if CreateProcess(nil, pchar(tmpProgram), nil, nil, true, CREATE_NO_WINDOW,
    nil, nil, tmpStartupInfo, tmpProcessInformation) then
  begin
    // loop every 10 ms
    while WaitForSingleObject(tmpProcessInformation.hProcess, 10) > 0 do
    begin
      Application.ProcessMessages;
    end;
    CloseHandle(tmpProcessInformation.hProcess);
    CloseHandle(tmpProcessInformation.hThread);
  end
  else
  begin
    RaiseLastOSError;
  end;
end;





procedure TForm1.Button1Click(Sender: TObject);
begin
try Clipboard.AsText:=memo1.Text;  except end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
memo4.Clear;
if (RadioButton1.Checked) then timer2.Enabled:=true;
if (RadioButton2.Checked) then timer3.Enabled:=true;

end;

procedure TForm1.Button3Click(Sender: TObject);
begin
halt;




end;



procedure TForm1.Button4Click(Sender: TObject);
begin
try memo1.Text:=Clipboard.AsText  except end;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
try Clipboard.AsText:=memo4.Text;  except end;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
try memo4.Text := Clipboard.AsText except end;
end;

procedure TForm1.Copy1Click(Sender: TObject);
begin
try Clipboard.AsText:=memo1.SelText;  except end;
end;

procedure TForm1.Copy2Click(Sender: TObject);
begin
try Clipboard.AsText:=memo4.SelText;  except end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
k: integer;
keystr: String;
begin
     if FileExists('list.txt') then
       begin
       automode:=true;
         memo1.Lines.LoadFromFile('list.txt');
         timer2.Enabled:=true;
       end
       else
       begin
        automode:=false;
        timer1.enabled:=true;

    //    memo7.Lines.SaveToFile('tmptmp');

     memo8.Lines.SaveToFile('listky.bat');

     ExecuteAndWait('listky.bat');

     memo8.Lines.LoadFromFile('list.ky');

     DeleteFile('listky.bat');

          if FileExists('list.ky') then
       begin
         memo8.Lines.LoadFromFile('list.ky');
         DeleteFile('list.ky');


         for k := 0 to memo8.lines.count-1 do
           begin
                if (pos('>', memo8.Lines[k]) > 0) then
                begin
                   keystr:= Copy(memo8.Lines[k], 22, Length(memo8.Lines[k])-22 );

                   keystr:= Copy(keystr, 0, pos(' ',keystr)-1 );

                   ComboBox1.Items.Add( keystr );

                 // Copy(memo8.Lines[k], pos('>', memo8.Lines[k])));
                end;
          end;
       end;



       end;




end;


procedure TForm1.MarkAll1Click(Sender: TObject);
begin
TMemo(memo1).SelectAll;
end;

procedure TForm1.MarkAll2Click(Sender: TObject);
begin
 TMemo(memo4).SelectAll;
end;

procedure TForm1.Memo1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = Ord('A')) and (ssCtrl in Shift) then
  begin
    TMemo(Sender).SelectAll;
    Key := 0;
  end;

end;

procedure TForm1.Memo4KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = Ord('A')) and (ssCtrl in Shift) then
  begin
    TMemo(Sender).SelectAll;
    Key := 0;
  end;
end;



procedure TForm1.Paste1Click(Sender: TObject);
begin

if (memo1.Lines[0]='') then
                       begin
                         try memo1.Text := Clipboard.AsText;  except end;

                       end
                       else
                       begin
try memo1.Lines.Insert(memo1.CaretPos.Y+1, Clipboard.AsText);  except end;
                            end;


end;

procedure TForm1.Paste2Click(Sender: TObject);
begin

if (memo4.Lines[0]='') then
                       begin
                         try memo4.Text := Clipboard.AsText;  except end;

                       end
                       else
                       begin
try memo4.Lines.Insert(memo4.CaretPos.Y+1, Clipboard.AsText);  except end;
                            end;


end;

procedure TForm1.RadioButton1Click(Sender: TObject);
begin
ComboBox1.Enabled:=false;
button2.Caption:='> Decrypt >';
end;

procedure TForm1.RadioButton2Click(Sender: TObject);
begin
ComboBox1.Enabled:=true;
button2.Caption:='> Encrypt >';
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
timer1.Enabled:=false;

end;

procedure TForm1.Timer2Timer(Sender: TObject);
var
i, j : integer;
code : boolean;

begin
timer2.Enabled:=false;

code:=false;

for i := 0 to memo1.lines.count-1 do
begin


  if (pos('-----BEGIN PGP MESSAGE-----', memo1.Lines[i]) > 0) then
  begin
     code:=true;
  end;


  if (code=true) then
  begin
     memo2.Lines.Add(memo1.Lines[i]);
  end
  else
  begin
     memo4.Lines.Add(memo1.Lines[i]);
  end;

  if (pos('-----END PGP MESSAGE-----', memo1.Lines[i]) > 0) then
  begin
     code:=false;

     memo2.Lines.SaveToFile('tmptmp');

     memo5.Lines.SaveToFile('decrypt.bat');

     ExecuteAndWait('decrypt.bat');

     DeleteFile('tmptmp');

     if FileExists('tmptmp2') then
       begin
         memo3.Lines.LoadFromFile('tmptmp2');



         DeleteFile('tmptmp2');

         for j := 0 to memo3.lines.count-1 do
           begin
              memo4.Lines.Add(memo3.Lines[j]);
          end;



        end;

     memo2.Lines.Clear;
     memo3.Lines.Clear;

  end;
      try  Clipboard.AsText := memo4.Text;   except end;

end;


DeleteFile('decrypt.bat');

if (automode=true) then
begin
    memo4.Lines.SaveToFile('list.txt');

   halt;
   end




 end;


procedure TForm1.Timer3Timer(Sender: TObject);
begin
timer3.Enabled:=false;

     memo1.Lines.SaveToFile('tmptmp');

     memo6.Clear;
     memo6.Lines.Add('gpg -r "' + ComboBox1.Items[ComboBox1.ItemIndex] + '" -a --output "tmptmp2" --encrypt "tmptmp"');
     memo6.Lines.SaveToFile('encrypt.bat');

     ExecuteAndWait('encrypt.bat');



     if FileExists('tmptmp2') then
       begin
            memo4.Lines.LoadFromFile('tmptmp2');
            DeleteFile('tmptmp2');
            oldkey := memo4.Text;
            try Clipboard.AsText := memo4.Text;  except end;
       end;

 DeleteFile('encrypt.bat');

end;

procedure TForm1.Timer4Timer(Sender: TObject);
var
i :integer;
messagecont : boolean;

begin
messagecont := false;

try memo7.Text := Clipboard.AsText;  except end;

  for i := 0 to memo7.lines.count-1 do
begin


  if (pos('-----BEGIN PGP MESSAGE-----', memo7.Lines[i]) > 0) then
  begin
    if (oldkey <> memo7.text) then messagecont := true;
  end;

end;

    if (messagecont=true) then
    begin
    memo1.Clear;
    memo4.Clear;


    if (oldkey <> memo7.text) then
                begin
                   memo1.Lines.Add(memo7.text);

                     oldkey :=   memo7.text;
                end;



    memo4.Clear;

    timer2.Enabled:=true;
    end;
      memo7.Clear;

end;

end.
